#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string>

using namespace std;

class Param
{
public:
  string fileName;
  int    size;
  char   ch;

public:
  Param()
  {
    fileName = "";
    size     = 0;
    ch       = '\0';
  }
  ~Param()
  {
  }

public:
  bool parse(int argc, char* argv[])
  {
    if (argc != 4) return false;
    fileName = argv[1];
    size     = atoi(argv[2]);
    ch       = *argv[3];
    return true;
  }

  static void usage()
  {
    cout << "big_file version 1.0\n";
    cout << "Copyright (c) Gilbert Lee All rights reserved\n";
    cout << "\n";
    cout << "big_file <filename> <size> <character>\n";
    cout << "\n";
    cout << "example\n";
    cout << "\n";
    cout << "  big_file 1K.txt 1024 1\n";
    cout << "  big_file 1M.txt 1048576 1\n";
    cout << "  big_file 1G.txt 1073741824 A\n";
  }
};

bool makeFile(string fileName, int size, char ch)
{
  FILE* fp = fopen(fileName.c_str(), "wb");
  if (fp == NULL) return false;
  for (int i = 0; i < size; i++)
  {
    size_t res = fwrite(&ch, 1, 1, fp);
    if (res != 1) return false;
  }
  fclose(fp);
  return true;
}

int main(int argc, char* argv[])
{
  Param param;
  if (!param.parse(argc, argv))
  {
    Param::usage();
    return 0;
  }

  bool res = makeFile(param.fileName, param.size, param.ch);
  if (res)
    cout << "make " << param.fileName << " successfully\n";
  else
    cout << "make " << param.fileName << " failed\n";
  return 0;
}
